FFMPEG(1)

NAME
ffmpeg - FFmpeg video converter

SYNOPSIS
ffmpeg [[infile options][-i infile]]... {[outfile options] outfile}...

DESCRIPTION
FFmpeg is a very fast video and audio converter. It can also grab from a live audio/video source.

The command line interface is designed to be intuitive, in the sense that FFmpeg tries to figure out all parameters that can possibly be derived automatically. You usually only have to specify the target bitrate you want.

FFmpeg can also convert from any sample rate to any other, and resize video on the fly with a high quality polyphase filter.

As a general rule, options are applied to the next specified file. Therefore, order is important, and you can have the same option on the command line multiple times. Each occurrence is then applied to the next input or output file.

* To set the video bitrate of the output file to 64kbit/s:

        ffmpeg -i input.avi -b 64k output.avi

* To force the frame rate of the output file to 24 fps:

        ffmpeg -i input.avi -r 24 output.avi

* To force the frame rate of the input file (valid for raw formats only) to 1 fps and the frame rate of the output file to 24 fps:

        ffmpeg -r 1 -i input.m2v -r 24 output.avi

The format option may be needed for raw input files.

By default, FFmpeg tries to convert as losslessly as possible: It uses the same audio and video parameters for the outputs as the one specified for the inputs.

OPTIONS
All the numerical options, if not specified otherwise, accept in input a string representing a number, which may contain one of the International System number postfixes, for example 'K', 'M', 'G'. If 'i' is appended after the postfix, powers of 2 are used instead of powers of 10. The 'B' postfix multiplies the value for 8, and can be appended after another postfix or used alone. This allows using for example 'KB', 'MiB', 'G' and 'B' as postfix.

Options which do not take arguments are boolean options, and set the corresponding value to true. They can be set to false by prefixing with "no" the option name, for example using "-nofoo" in the commandline will set to false the boolean option with name "foo".

  Generic options
These options are shared amongst the ff* tools.

-L  Show license.

-h, -?, -help, --help
    Show help.

-version
    Show version.

-formats
    Show available formats.

    The fields preceding the format names have the following meanings:

    D   Decoding available

    E   Encoding available

-codecs
    Show available codecs.

    The fields preceding the codec names have the following meanings:

    D   Decoding available

    E   Encoding available

    V/A/S
        Video/audio/subtitle codec

    S   Codec supports slices

    D   Codec supports direct rendering

    T   Codec can handle input truncated at random locations instead of only at frame boundaries

-bsfs
    Show available bitstream filters.

-protocols
    Show available protocols.

-filters
    Show available libavfilter filters.

-pix_fmts
    Show available pixel formats.

-loglevel loglevel
    Set the logging level used by the library. loglevel is a number or a string containing one of the following values:

    quiet
    panic
    fatal
    error
    warning
    info
    verbose
    debug

    By default the program logs to stderr, if coloring is supported by the terminal, colors are used to mark errors and warnings. Log coloring can be disabled setting the environment variable NO_COLOR.

  Main options

-f fmt
    Force format.

-i filename
    input file name

-y  Overwrite output files.

-t duration
    Restrict the transcoded/captured video sequence to the duration specified in seconds. "hh:mm:ss[.xxx]" syntax is also supported.

-fs limit_size
    Set the file size limit.

-ss position
    Seek to given time position in seconds. "hh:mm:ss[.xxx]" syntax is also supported.

-itsoffset offset
    Set the input time offset in seconds. "[-]hh:mm:ss[.xxx]" syntax is also supported. This option affects all the input files that follow it. The offset is added to the timestamps of the input files. Specifying a positive offset means that the corresponding streams are delayed by 'offset' seconds.

-timestamp time
    Set the recording timestamp in the container. The syntax for time is:

            now|([(YYYY-MM-DD|YYYYMMDD)[T|t| ]]((HH[:MM[:SS[.m...]]])|(HH[MM[SS[.m...]]]))[Z|z])

    If the value is "now" it takes the current time. Time is local time unless 'Z' or 'z' is appended, in which case it is interpreted as UTC. If the year-month-day part is not specified it takes the current year-month-day.

-metadata key=value
    Set a metadata key/value pair.

    For example, for setting the title in the output file:

            ffmpeg -i in.avi -metadata title="my title" out.flv

-v number
    Set the logging verbosity level.

-target type
    Specify target file type ("vcd", "svcd", "dvd", "dv", "dv50", "pal-vcd", "ntsc-svcd", ... ). All the format options (bitrate, codecs, buffer sizes) are then set automatically. You can just type:

            ffmpeg -i myfile.avi -target vcd /tmp/vcd.mpg

    Nevertheless you can specify additional options as long as you know they do not conflict with the standard, as in:

            ffmpeg -i myfile.avi -target vcd -bf 2 /tmp/vcd.mpg

-dframes number
    Set the number of data frames to record.

-scodec codec
    Force subtitle codec ('copy' to copy stream).

-newsubtitle
    Add a new subtitle stream to the current output stream.

-slang code
    Set the ISO 639 language code (3 letters) of the current subtitle stream.

  Video Options

-b bitrate
    Set the video bitrate in bit/s (default = 200 kb/s).

-vframes number
    Set the number of video frames to record.

-r fps
    Set frame rate (Hz value, fraction or abbreviation), (default = 25).

-s size
    Set frame size. The format is wxh (ffserver default = 160x128, ffmpeg default = same as source). The following abbreviations are recognized:

    sqcif
        128x96

    qcif
        176x144

    cif 352x288

    4cif
        704x576

    16cif
        1408x1152

    qqvga
        160x120

    qvga
        320x240

    vga 640x480

    svga
        800x600

    xga 1024x768

    uxga
        1600x1200

    qxga
        2048x1536

    sxga
        1280x1024

    qsxga
        2560x2048

    hsxga
        5120x4096

    wvga
        852x480

    wxga
        1366x768

    wsxga
        1600x1024

    wuxga
        1920x1200

    woxga
        2560x1600

    wqsxga
        3200x2048

    wquxga
        3840x2400

    whsxga
        6400x4096

    whuxga
        7680x4800

    cga 320x200

    ega 640x350

    hd480
        852x480

    hd720
        1280x720

    hd1080
        1920x1080

-aspect aspect
    Set aspect ratio (4:3, 16:9 or 1.3333, 1.7777).

-croptop size (deprecated - use -vf crop=x:y:width:height instead)
    Set top crop band size (in pixels).

-cropbottom size (deprecated - use -vf crop=x:y:width:height instead)
    Set bottom crop band size (in pixels).

-cropleft size (deprecated - use -vf crop=x:y:width:height instead)
    Set left crop band size (in pixels).

-cropright size (deprecated - use -vf crop=x:y:width:height instead)
    Set right crop band size (in pixels).

-padtop size
-padbottom size
-padleft size
-padright size
-padcolor hex_color
    All the pad options have been removed. Use -vf pad=width:height:x:y:color instead.

-vn Disable video recording.

-bt tolerance
    Set video bitrate tolerance (in bits, default 4000k). Has a minimum value of: (target_bitrate/target_framerate). In 1-pass mode, bitrate tolerance specifies how far ratecontrol is willing to deviate from the target average bitrate value. This is not related to min/max bitrate. Lowering tolerance too much has an adverse effect on quality.

-maxrate bitrate
    Set max video bitrate (in bit/s). Requires -bufsize to be set.

-minrate bitrate
    Set min video bitrate (in bit/s). Most useful in setting up a CBR encode:

            ffmpeg -i myfile.avi -b 4000k -minrate 4000k -maxrate 4000k -bufsize 1835k out.m2v

    It is of little use elsewise.

-bufsize size
    Set video buffer verifier buffer size (in bits).

-vcodec codec
    Force video codec to codec. Use the "copy" special value to tell that the raw codec data must be copied as is.

-sameq
    Use same video quality as source (implies VBR).

-pass n
    Select the pass number (1 or 2). It is used to do two-pass video encoding. The statistics of the video are recorded in the first pass into a log file (see also the option -passlogfile), and in the second pass that log file is used to generate the video at the exact requested bitrate. On pass 1, you may just deactivate audio and set output to null, examples for Windows and Unix:

            ffmpeg -i foo.mov -vcodec libxvid -pass 1 -an -f rawvideo -y NUL
            ffmpeg -i foo.mov -vcodec libxvid -pass 1 -an -f rawvideo -y /dev/null

-passlogfile prefix
    Set two-pass log file name prefix to prefix, the default file name prefix is ``ffmpeg2pass''. The complete file name will be PREFIX-N.log, where N is a number specific to the output stream.

-newvideo
    Add a new video stream to the current output stream.

-vlang code
    Set the ISO 639 language code (3 letters) of the current video stream.

-vf filter_graph
    filter_graph is a description of the filter graph to apply to the input video. Use the option "-filters" to show all the available filters (including also sources and sinks).

  Advanced Video Options

-pix_fmt format
    Set pixel format. Use 'list' as parameter to show all the supported pixel formats.

-sws_flags flags
    Set SwScaler flags.

-g gop_size
    Set the group of pictures size.

-intra
    Use only intra frames.

-vdt n
    Discard threshold.

-qscale q
    Use fixed video quantizer scale (VBR).

-qmin q
    minimum video quantizer scale (VBR)

-qmax q
    maximum video quantizer scale (VBR)

-qdiff q
    maximum difference between the quantizer scales (VBR)

-qblur blur
    video quantizer scale blur (VBR) (range 0.0 - 1.0)

-qcomp compression
    video quantizer scale compression (VBR) (default 0.5). Constant of ratecontrol equation. Recommended range for default rc_eq: 0.0-1.0

-lmin lambda
    minimum video lagrange factor (VBR)

-lmax lambda
    max video lagrange factor (VBR)

-mblmin lambda
    minimum macroblock quantizer scale (VBR)

-mblmax lambda
    maximum macroblock quantizer scale (VBR)

    These four options (lmin, lmax, mblmin, mblmax) use 'lambda' units, but you may use the QP2LAMBDA constant to easily convert from 'q' units:

            ffmpeg -i src.ext -lmax 21*QP2LAMBDA dst.ext

-rc_init_cplx complexity
    initial complexity for single pass encoding

-b_qfactor factor
    qp factor between P- and B-frames

-i_qfactor factor
    qp factor between P- and I-frames

-b_qoffset offset
    qp offset between P- and B-frames

-i_qoffset offset
    qp offset between P- and I-frames

-rc_eq equation
    Set rate control equation (default = "tex^qComp").

-rc_override override
    rate control override for specific intervals

-me_method method
    Set motion estimation method to method. Available methods are (from lowest to best quality):

    zero
        Try just the (0, 0) vector.

    phods
    log
    x1
    hex
    umh
    epzs
        (default method)

    full
        exhaustive search (slow and marginally better than epzs)

-dct_algo algo
    Set DCT algorithm to algo. Available values are:

    0   FF_DCT_AUTO (default)

    1   FF_DCT_FASTINT

    2   FF_DCT_INT

    3   FF_DCT_MMX

    4   FF_DCT_MLIB

    5   FF_DCT_ALTIVEC

-idct_algo algo
    Set IDCT algorithm to algo. Available values are:

    0   FF_IDCT_AUTO (default)

    1   FF_IDCT_INT

    2   FF_IDCT_SIMPLE

    3   FF_IDCT_SIMPLEMMX

    4   FF_IDCT_LIBMPEG2MMX

    5   FF_IDCT_PS2

    6   FF_IDCT_MLIB

    7   FF_IDCT_ARM

    8   FF_IDCT_ALTIVEC

    9   FF_IDCT_SH4

    10  FF_IDCT_SIMPLEARM

-er n
    Set error resilience to n.

    1   FF_ER_CAREFUL (default)

    2   FF_ER_COMPLIANT

    3   FF_ER_AGGRESSIVE

    4   FF_ER_VERY_AGGRESSIVE

-ec bit_mask
    Set error concealment to bit_mask. bit_mask is a bit mask of the following values:

    1   FF_EC_GUESS_MVS (default = enabled)

    2   FF_EC_DEBLOCK (default = enabled)

-bf frames
    Use 'frames' B-frames (supported for MPEG-1, MPEG-2 and MPEG-4).

-mbd mode
    macroblock decision

    0   FF_MB_DECISION_SIMPLE: Use mb_cmp (cannot change it yet in FFmpeg).

    1   FF_MB_DECISION_BITS: Choose the one which needs the fewest bits.

    2   FF_MB_DECISION_RD: rate distortion

-4mv
    Use four motion vector by macroblock (MPEG-4 only).

-part
    Use data partitioning (MPEG-4 only).

-bug param
    Work around encoder bugs that are not auto-detected.

-strict strictness
    How strictly to follow the standards.

-aic
    Enable Advanced intra coding (h263+).

-umv
    Enable Unlimited Motion Vector (h263+)

-deinterlace
    Deinterlace pictures.

-ilme
    Force interlacing support in encoder (MPEG-2 and MPEG-4 only). Use this option if your input file is interlaced and you want to keep the interlaced format for minimum losses. The alternative is to deinterlace the input stream with -deinterlace, but deinterlacing introduces losses.

-psnr
    Calculate PSNR of compressed frames.

-vstats
    Dump video coding statistics to vstats_HHMMSS.log.

-vstats_file file
    Dump video coding statistics to file.

-top n
    top=1/bottom=0/auto=-1 field first

-dc precision
    Intra_dc_precision.

-vtag fourcc/tag
    Force video tag/fourcc.

-qphist
    Show QP histogram.

-vbsf bitstream_filter
    Bitstream filters available are "dump_extra", "remove_extra", "noise", "h264_mp4toannexb", "imxdump", "mjpegadump".

            ffmpeg -i h264.mp4 -vcodec copy -vbsf h264_mp4toannexb -an out.h264

  Audio Options

-aframes number
    Set the number of audio frames to record.

-ar freq
    Set the audio sampling frequency (default = 44100 Hz).

-ab bitrate
    Set the audio bitrate in bit/s (default = 64k).

-aq q
    Set the audio quality (codec-specific, VBR).

-ac channels
    Set the number of audio channels (default = 1).

-an Disable audio recording.

-acodec codec
    Force audio codec to codec. Use the "copy" special value to specify that the raw codec data must be copied as is.

-newaudio
    Add a new audio track to the output file. If you want to specify parameters, do so before "-newaudio" ("-acodec", "-ab", etc..).

    Mapping will be done automatically, if the number of output streams is equal to the number of input streams, else it will pick the first one that matches. You can override the mapping using "-map" as usual.

    Example:

            ffmpeg -i file.mpg -vcodec copy -acodec ac3 -ab 384k test.mpg -acodec mp2 -ab 192k -newaudio

-alang code
    Set the ISO 639 language code (3 letters) of the current audio stream.

  Advanced Audio options:

-atag fourcc/tag
    Force audio tag/fourcc.

-absf bitstream_filter
    Bitstream filters available are "dump_extra", "remove_extra", "noise", "mp3comp", "mp3decomp".

  Subtitle options:

-scodec codec
    Force subtitle codec ('copy' to copy stream).

-newsubtitle
    Add a new subtitle stream to the current output stream.

-slang code
    Set the ISO 639 language code (3 letters) of the current subtitle stream.

-sn Disable subtitle recording.

-sbsf bitstream_filter
    Bitstream filters available are "mov2textsub", "text2movsub".

            ffmpeg -i file.mov -an -vn -sbsf mov2textsub -scodec copy -f rawvideo sub.txt

  Audio/Video grab options

-vc channel
    Set video grab channel (DV1394 only).

-tvstd standard
    Set television standard (NTSC, PAL (SECAM)).

-isync
    Synchronize read on input.

  Advanced options

-map input_stream_id[:sync_stream_id]
    Set stream mapping from input streams to output streams. Just enumerate the input streams in the order you want them in the output. sync_stream_id if specified sets the input stream to sync against.

-map_meta_data outfile:infile
    Set meta data information of outfile from infile.

-debug
    Print specific debug info.

-benchmark
    Show benchmarking information at the end of an encode. Shows CPU time used and maximum memory consumption. Maximum memory consumption is not supported on all systems, it will usually display as 0 if not supported.

-dump
    Dump each input packet.

-hex
    When dumping packets, also dump the payload.

-bitexact
    Only use bit exact algorithms (for codec testing).

-ps size
    Set RTP payload size in bytes.

-re Read input at native frame rate. Mainly used to simulate a grab device.

-loop_input
    Loop over the input stream. Currently it works only for image streams. This option is used for automatic FFserver testing.

-loop_output number_of_times
    Repeatedly loop output for formats that support looping such as animated GIF (0 will loop the output infinitely).

-threads count
    Thread count.

-vsync parameter
    Video sync method. 0 Each frame is passed with its timestamp from the demuxer to the muxer 1 Frames will be duplicated and dropped to achieve exactly the requested
        constant framerate. 2 Frames are passed through with their timestamp or dropped so as to prevent
        2 frames from having the same timestamp -1 Chooses between 1 and 2 depending on muxer capabilities. This is the default method.

    With -map you can select from which stream the timestamps should be taken. You can leave either video or audio unchanged and sync the remaining stream(s) to the unchanged one.

-async samples_per_second
    Audio sync method. "Stretches/squeezes" the audio stream to match the timestamps, the parameter is the maximum samples per second by which the audio is changed. -async 1 is a special case where only the start of the audio stream is corrected without any later correction.

-copyts
    Copy timestamps from input to output.

-shortest
    Finish encoding when the shortest input stream ends.

-dts_delta_threshold
    Timestamp discontinuity delta threshold.

-muxdelay seconds
    Set the maximum demux-decode delay.

-muxpreload seconds
    Set the initial demux-decode delay.

-streamid output-stream-index:new-value
    Assign a new value to a stream's stream-id field in the next output file. All stream-id fields are reset to default for each output file.

    For example, to set the stream 0 PID to 33 and the stream 1 PID to 36 for an output mpegts file:

            ffmpeg -i infile -streamid 0:33 -streamid 1:36 out.ts

  Preset files
A preset file contains a sequence of option=value pairs, one for each line, specifying a sequence of options which would be awkward to specify on the command line. Lines starting with the hash ('#') character are ignored and are used to provide comments. Check the ffpresets directory in the FFmpeg source tree for examples.

Preset files are specified with the "vpre", "apre", "spre", and "fpre" options. The "fpre" option takes the filename of the preset instead of a preset name as input and can be used for any kind of codec. For the "vpre", "apre", and "spre" options, the options specified in a preset file are applied to the currently selected codec of the same type as the preset option.

The argument passed to the "vpre", "apre", and "spre" preset options identifies the preset file to use according to the following rules:

First ffmpeg searches for a file named arg.ffpreset in the directories $FFMPEG_DATADIR (if set), and $HOME/.ffmpeg, and in the datadir defined at configuration time (usually PREFIX/share/ffmpeg) in that order. For example, if the argument is "libx264-max", it will search for the file libx264-max.ffpreset.

If no such file is found, then ffmpeg will search for a file named codec_name-arg.ffpreset in the above-mentioned directories, where codec_name is the name of the codec to which the preset file options will be applied. For example, if you select the video codec with "-vcodec libx264" and use "-vpre max", then it will search for the file libx264-max.ffpreset.

@anchor{FFmpeg formula evaluator}

  FFmpeg formula evaluator
When evaluating a rate control string, FFmpeg uses an internal formula evaluator.

The following binary operators are available: "+", "-", "*", "/", "^".

The following unary operators are available: "+", "-", "(...)".

The following statements are available: "ld", "st", "while".

The following functions are available:

sinh(x)
cosh(x)
tanh(x)
sin(x)
cos(x)
tan(x)
atan(x)
asin(x)
acos(x)
exp(x)
log(x)
abs(x)
squish(x)
gauss(x)
mod(x, y)
max(x, y)
min(x, y)
eq(x, y)
gte(x, y)
gt(x, y)
lte(x, y)
lt(x, y)
bits2qp(bits)
qp2bits(qp)

The following constants are available:

PI
E
iTex
pTex
tex
mv
fCode
iCount
mcVar
var
isI
isP
isB
avgQP
qComp
avgIITex
avgPITex
avgPPTex
avgBPTex
avgTex

TIPS

•   For streaming at very low bitrate application, use a low frame rate and a small GOP size. This is especially true for RealVideo where the Linux player does not seem to be very fast, so it can miss frames. An example is:

            ffmpeg -g 3 -r 3 -t 10 -b 50k -s qcif -f rv10 /tmp/b.rm

•   The parameter 'q' which is displayed while encoding is the current quantizer. The value 1 indicates that a very good quality could be achieved. The value 31 indicates the worst quality. If q=31 appears too often, it means that the encoder cannot compress enough to meet your bitrate. You must either increase the bitrate, decrease the frame rate or decrease the frame size.

•   If your computer is not fast enough, you can speed up the compression at the expense of the compression ratio. You can use '-me zero' to speed up motion estimation, and '-intra' to disable motion estimation completely (you have only I-frames, which means it is about as good as JPEG compression).

•   To have very low audio bitrates, reduce the sampling frequency (down to 22050 Hz for MPEG audio, 22050 or 11025 for AC-3).

•   To have a constant quality (but a variable bitrate), use the option '-qscale n' when 'n' is between 1 (excellent quality) and 31 (worst quality).

•   When converting video files, you can use the '-sameq' option which uses the same quality factor in the encoder as in the decoder. It allows almost lossless encoding.

EXAMPLES

  Video and Audio grabbing
FFmpeg can grab video and audio from devices given that you specify the input format and device.

        ffmpeg -f oss -i /dev/dsp -f video4linux2 -i /dev/video0 /tmp/out.mpg

Note that you must activate the right video source and channel before launching FFmpeg with any TV viewer such as xawtv (<http://linux.bytesex.org/xawtv/>) by Gerd Knorr. You also have to set the audio recording levels correctly with a standard mixer.

  X11 grabbing
FFmpeg can grab the X11 display.

        ffmpeg -f x11grab -s cif -i :0.0 /tmp/out.mpg

0.0 is display.screen number of your X11 server, same as the DISPLAY environment variable.

        ffmpeg -f x11grab -s cif -i :0.0+10,20 /tmp/out.mpg

0.0 is display.screen number of your X11 server, same as the DISPLAY environment variable. 10 is the x-offset and 20 the y-offset for the grabbing.

  Video and Audio file format conversion
* FFmpeg can use any supported file format and protocol as input:

Examples:

* You can use YUV files as input:

        ffmpeg -i /tmp/test%d.Y /tmp/out.mpg

It will use the files:

        /tmp/test0.Y, /tmp/test0.U, /tmp/test0.V,
        /tmp/test1.Y, /tmp/test1.U, /tmp/test1.V, etc...

The Y files use twice the resolution of the U and V files. They are raw files, without header. They can be generated by all decent video decoders. You must specify the size of the image with the -s option if FFmpeg cannot guess it.

* You can input from a raw YUV420P file:

        ffmpeg -i /tmp/test.yuv /tmp/out.avi

test.yuv is a file containing raw YUV planar data. Each frame is composed of the Y plane followed by the U and V planes at half vertical and horizontal resolution.

* You can output to a raw YUV420P file:

        ffmpeg -i mydivx.avi hugefile.yuv

* You can set several input files and output files:

        ffmpeg -i /tmp/a.wav -s 640x480 -i /tmp/a.yuv /tmp/a.mpg

Converts the audio file a.wav and the raw YUV video file a.yuv to MPEG file a.mpg.

* You can also do audio and video conversions at the same time:

        ffmpeg -i /tmp/a.wav -ar 22050 /tmp/a.mp2

Converts a.wav to MPEG audio at 22050 Hz sample rate.

* You can encode to several formats at the same time and define a mapping from input stream to output streams:

        ffmpeg -i /tmp/a.wav -ab 64k /tmp/a.mp2 -ab 128k /tmp/b.mp2 -map 0:0 -map 0:0

Converts a.wav to a.mp2 at 64 kbits and to b.mp2 at 128 kbits. '-map file:index' specifies which input stream is used for each output stream, in the order of the definition of output streams.

* You can transcode decrypted VOBs:

        ffmpeg -i snatch_1.vob -f avi -vcodec mpeg4 -b 800k -g 300 -bf 2 -acodec libmp3lame -ab 128k snatch.avi

This is a typical DVD ripping example; the input is a VOB file, the output an AVI file with MPEG-4 video and MP3 audio. Note that in this command we use B-frames so the MPEG-4 stream is DivX5 compatible, and GOP size is 300 which means one intra frame every 10 seconds for 29.97fps input video. Furthermore, the audio stream is MP3-encoded so you need to enable LAME support by passing "--enable-libmp3lame" to configure. The mapping is particularly useful for DVD transcoding to get the desired audio language.

NOTE: To see the supported input formats, use "ffmpeg -formats".

* You can extract images from a video, or create a video from many images:

For extracting images from a video:

        ffmpeg -i foo.avi -r 1 -s WxH -f image2 foo-%03d.jpeg

This will extract one video frame per second from the video and will output them in files named foo-001.jpeg, foo-002.jpeg, etc. Images will be rescaled to fit the new WxH values.

If you want to extract just a limited number of frames, you can use the above command in combination with the -vframes or -t option, or in combination with -ss to start extracting from a certain point in time.

For creating a video from many images:

        ffmpeg -f image2 -i foo-%03d.jpeg -r 12 -s WxH foo.avi

The syntax "foo-%03d.jpeg" specifies to use a decimal number composed of three digits padded with zeroes to express the sequence number. It is the same syntax supported by the C printf function, but only formats accepting a normal integer are suitable.

* You can put many streams of the same type in the output:

        ffmpeg -i test1.avi -i test2.avi -vcodec copy -acodec copy -vcodec copy -acodec copy test12.avi -newvideo -newaudio

In addition to the first video and audio streams, the resulting output file test12.avi will contain the second video and the second audio stream found in the input streams list.

The "-newvideo", "-newaudio" and "-newsubtitle" options have to be specified immediately after the name of the output file to which you want to add them.

INPUT DEVICES
Input devices are configured elements in FFmpeg which allow to access the data coming from a multimedia device attached to your system.

When you configure your FFmpeg build, all the supported input devices are enabled by default. You can list them using the configure option "--list-indevs".

You can disable all the input devices using the configure option "--disable-indevs", and selectively enable an input device using the option "--enable-indev=INDEV", or you can disable a particular input device using the option "--disable-indev=INDEV".

The option "-formats" of the ff* tools will display the list of supported input devices (amongst the demuxers).

A description of the currently available input devices follows.

  alsa
ALSA (Advanced Linux Sound Architecture) input device.

To enable this input device during configuration you need libasound installed on your system.

This device allows to capture from an ALSA device. The name of the device to capture has to be an ALSA card identifier.

An ALSA identifier has the syntax:

        hw:<CARD>[,<DEV>[,<SUBDEV>]]

where the DEV and SUBDEV components are optional.

The three arguments (in order: CARD,DEV,SUBDEV) specify card number or identifier, device number and subdevice number (-1 means any).

To see the list of cards currently recognized by your system check the files /proc/asound/cards and /proc/asound/devices.

For example to capture with ffmpeg from an alsa device with card id 0, you may run the command:

        ffmpeg -f alsa -i hw:0 alsaout.wav

For more information see: <http://www.alsa-project.org/alsa-doc/alsa-lib/pcm.html>

  audio_beos
BeOS audio input device.

  bktr
BSD video input device.

  dv1394
Linux DV 1394 input device.

  jack
Jack input device.

To enable this input device during configuration you need libjack installed on your system.

A jack input device creates one or more jack writable clients, one for each audio channel, with name client_name:input_N, where client_name is the name provided by the application, and N is a number which identifies the channel. Each writable client will send the acquired data to the FFmpeg input device.

Once you have created one or more jack readable clients, you need to connect them to one or more jack writable clients.

To connect or disconnect jack clients you can use the jack_connect and jack_disconnect programs, or do it through a graphical interface, for example with qjackctl.

To list the jack clients and their properties you can invoke the command jack_lsp.

Follows an example which shows how to capture a jack readable client with ffmpeg.

        # create a jack writable client with name "ffmpeg"
        $ ffmpeg -f jack -i ffmpeg -y out.wav

        # start the sample jack_metro readable client
        $ jack_metro -b 120 -d 0.2 -f 4000

        # list the current jack clients
        $ jack_lsp -c
        system:capture_1
        system:capture_2
        system:playback_1
        system:playback_2
        ffmpeg:input_1
        metro:120_bpm

        # connect metro to the ffmpeg writable client
        $ jack_connect metro:120_bpm ffmpeg:input_1

For more information read: <http://jackaudio.org/>

  libdc1394
IIDC1394 input device, based on libdc1394 and libraw1394.

  oss
Open Sound System input device.

The filename to provide to the input device is the device node representing the OSS input device, and is usually set to /dev/dsp/.

For example to grab from /dev/dsp/ using ffmpeg use the command:

        ffmpeg -f oss -i /dev/dsp /tmp/oss.wav

For more information about OSS see: <http://manuals.opensound.com/usersguide/dsp.html>

  video4linux and video4linux2
Video4Linux and Video4Linux2 input video devices.

The name of the device to grab is a file device node, usually Linux systems tend to automatically create such nodes when the device (e.g. an USB webcam) is plugged to the system, and has a name of the kind /dev/videoN, where N is a number associated to the device.

Video4Linux and Video4Linux2 devices only support a limited set of widthxheight sizes and framerates. You can check which are supported for example using the command dov4l for Video4Linux devices, and the command v4l-info for Video4Linux2 devices.

If the size for the device is set to 0x0, the input device will try to autodetect the size to use.

Video4Linux support is deprecated since Linux 2.6.30, and will be dropped in later versions.

Follow some usage examples of the video4linux devices with the ff* tools.

        # grab and show the input of a video4linux device
        ffplay -s 320x240 -f video4linux /dev/video0

        # grab and show the input of a video4linux2 device, autoadjust size
        ffplay -f video4linux2 /dev/video0

        # grab and record the input of a video4linux2 device, autoadjust size
        ffmpeg -f video4linux2 -i /dev/video0 out.mpeg

  vfwcap
VFW (Video For Window) catpure input device.

  x11grab
X11 video input device.

This device allows to capture a region of an X11 display.

The filename passed in input has the syntax:

        [<hostname>]:<display_number>.<screen_number>[+<x_offset>,<y_offset>]

hostname:display_number.screen_number specifies the X11 display name of the screen to grab from. hostname can be not specified, and defaults to "localhost". The environment variable DISPLAY contains the default display name.

x_offset and y_offset specify the offsets of the grabbed area with respect to the top/left border of the X11 screen image. They default to 0.

Check the X11 documentation (e.g. man X) for more detailed information.

Use the dpyinfo program for getting basic information about the properties of your X11 display screen (e.g. grep for "name" or "dimensions").

For example to grab from :0.0 using ffmpeg:

        ffmpeg -f x11grab -r 25 -s cif -i :0.0 out.mpg

        # grab at position 10,20
        ffmpeg -f x11grab -25 -s cif -i :0.0+10,20 out.mpg

OUTPUT DEVICES
Output devices are configured elements in FFmpeg which allow to write multimedia data to an output device attached to your system.

When you configure your FFmpeg build, all the supported output devices are enabled by default. You can list them using the configure option "--list-outdevs".

You can disable all the output devices using the configure option "--disable-outdevs", and selectively enable an output device using the option "--enable-outdev=OUTDEV", or you can disable a particular input device using the option "--disable-outdev=OUTDEV".

The option "-formats" of the ff* tools will display the list of enabled output devices (amongst the muxers).

A description of the currently available output devices follows.

  alsa
ALSA (Advanced Linux Sound Architecture) output device.

  audio_beos
BeOS audio output device.

  oss
OSS (Open Sound System) output device.

VIDEO FILTERS
When you configure your FFmpeg build, you can disable any of the existing filters using --disable-filters. The configure output will show the video filters included in your build.

Below is a description of the currently available video filters.

  crop
Crop the input video to x:y:width:height.

        ./ffmpeg -i in.avi -vf "crop=0:0:0:240" out.avi

x and y specify the position of the top-left corner of the output (non-cropped) area.

The default value of x and y is 0.

The width and height parameters specify the width and height of the output (non-cropped) area.

A value of 0 is interpreted as the maximum possible size contained in the area delimited by the top-left corner at position x:y.

For example the parameters:

        "crop=100:100:0:0"

will delimit the rectangle with the top-left corner placed at position 100:100 and the right-bottom corner corresponding to the right-bottom corner of the input image.

The default value of width and height is 0.

  format
Convert the input video to one of the specified pixel formats. Libavfilter will try to pick one that is supported for the input to the next filter.

The filter accepts a list of pixel format names, separated by ``:'', for example ``yuv420p:monow:rgb24''.

The following command:

        ./ffmpeg -i in.avi -vf "format=yuv420p" out.avi

will convert the input video to the format ``yuv420p''.

  noformat
Force libavfilter not to use any of the specified pixel formats for the input to the next filter.

The filter accepts a list of pixel format names, separated by ``:'', for example ``yuv420p:monow:rgb24''.

The following command:

        ./ffmpeg -i in.avi -vf "noformat=yuv420p, vflip" out.avi

will make libavfilter use a format different from ``yuv420p'' for the input to the vflip filter.

  null
Pass the source unchanged to the output.

  pad
Add paddings to the input image, and places the original input at the given coordinates x, y.

It accepts the following parameters: width:height:x:y:color.

Follows the description of the accepted parameters.

width, height
    Specify the size of the output image with the paddings added. If the value for width or height is 0, the corresponding input size is used for the output.

    The default value of width and height is 0.

x, y
    Specify the offsets where to place the input image in the padded area with respect to the top/left border of the output image.

    The default value of x and y is 0.

color
    Specify the color of the padded area, it can be the name of a color (case insensitive match) or a 0xRRGGBB[AA] sequence.

    The default value of color is ``black''.

  pixdesctest
Pixel format descriptor test filter, mainly useful for internal testing. The output video should be equal to the input video.

For example:

        format=monow, pixdesctest

can be used to test the monowhite pixel format descriptor definition.

  scale
Scale the input video to width:height and/or convert the image format.

For example the command:

        ./ffmpeg -i in.avi -vf "scale=200:100" out.avi

will scale the input video to a size of 200x100.

If the input image format is different from the format requested by the next filter, the scale filter will convert the input to the requested format.

If the value for width or height is 0, the respective input size is used for the output.

If the value for width or height is -1, the scale filter will use, for the respective output size, a value that maintains the aspect ratio of the input image.

The default value of width and height is 0.

  slicify
Pass the images of input video on to next video filter as multiple slices.

        ./ffmpeg -i in.avi -vf "slicify=32" out.avi

The filter accepts the slice height as parameter. If the parameter is not specified it will use the default value of 16.

Adding this in the beginning of filter chains should make filtering faster due to better use of the memory cache.

  unsharp
Sharpen or blur the input video.

It accepts the following parameters: luma_msize_x:luma_msize_y:luma_amount:chroma_msize_x:chroma_msize_y:chroma_amount

Negative values for the amount will blur the input video, while positive values will sharpen. All parameters are optional and default to the equivalent of the string '5:5:1.0:0:0:0.0'.

luma_msize_x
    Set the luma matrix horizontal size. It can be an integer between 3 and 13, default value is 5.

luma_msize_y
    Set the luma matrix vertical size. It can be an integer between 3 and 13, default value is 5.

luma_amount
    Set the luma effect strength. It can be a float number between -2.0 and 5.0, default value is 1.0.

chroma_msize_x
    Set the chroma matrix horizontal size. It can be an integer between 3 and 13, default value is 0.

chroma_msize_y
    Set the chroma matrix vertical size. It can be an integer between 3 and 13, default value is 0.

luma_amount
    Set the chroma effect strength. It can be a float number between -2.0 and 5.0, default value is 0.0.

        # Strong luma sharpen effect parameters
        unsharp=7:7:2.5

        # Strong blur of both luma and chroma parameters
        unsharp=7:7:-2:7:7:-2

        # Use the default values with B<ffmpeg>
        ./ffmpeg -i in.avi -vf "unsharp" out.mp4

  vflip
Flip the input video vertically.

        ./ffmpeg -i in.avi -vf "vflip" out.avi

VIDEO SOURCES
Below is a description of the currently available video sources.

  buffer
Buffer video frames, and make them available to the filter chain.

This source is mainly intended for a programmatic use, in particular through the interface defined in libavfilter/vsrc_buffer.h.

It accepts the following parameters: width:height:pix_fmt_string

All the parameters need to be explicitely defined.

Follows the list of the accepted parameters.

width, height
    Specify the width and height of the buffered video frames.

pix_fmt_string
    A string representing the pixel format of the buffered video frames. It may be a number corresponding to a pixel format, or a pixel format name.

For example:

        buffer=320:240:yuv410p

will instruct the source to accept video frames with size 320x240 and with format "yuv410p". Since the pixel format with name "yuv410p" corresponds to the number 6 (check the enum PixelFormat definition in libavutil/pixfmt.h), this example corresponds to:

        buffer=320:240:6

  color
Provide an uniformly colored input.

It accepts the following parameters: color:frame_size:frame_rate

Follows the description of the accepted parameters.

color
    Specify the color of the source. It can be the name of a color (case insensitive match) or a 0xRRGGBB[AA] sequence, possibly followed by an alpha specifier. The default value is "black".

frame_size
    Specify the size of the sourced video, it may be a string of the form widthxheigth, or the name of a size abbreviation. The default value is "320x240".

frame_rate
    Specify the frame rate of the sourced video, as the number of frames generated per second. It has to be a string in the format frame_rate_num/frame_rate_den, an integer number, a float number or a valid video frame rate abbreviation. The default value is "25".

For example the following graph description will generate a red source with an opacity of 0.2, with size "qcif" and a frame rate of 10 frames per second, which will be overlayed over the source connected to the pad with identifier "in".

        "color=red@0.2:qcif:10 [color]; [in][color] overlay [out]"

  nullsrc
Null video source, never return images. It is mainly useful as a template and to be employed in analysis / debugging tools.

It accepts as optional parameter a string of the form width:height, where width and height specify the size of the configured source.

The default values of width and height are respectively 352 and 288 (corresponding to the CIF size format).

VIDEO SINKS
Below is a description of the currently available video sinks.

  nullsink
Null video sink, do absolutely nothing with the input video. It is mainly useful as a template and to be employed in analysis / debugging tools.

SEE ALSO
ffplay(1), ffprobe(1), ffserver(1) and the FFmpeg HTML documentation

AUTHORS
The FFmpeg developers